Subject: [Tomas Nordin] Re: Unbalanced closing paren in help of git commit

From: Tomas Nordin <[email-masked]>
Date: Tue, 09 Jul 2024 23:07:49 +0000

[Sorry, I think I forgot to CC the list when I sent the below message]

-------------------- Start of forwarded message --------------------
From: Tomas Nordin <[email-masked]>
To: Junio C Hamano <[email-masked]>
Subject: Re: Unbalanced closing paren in help of git commit
Date: Mon, 08 Jul 2024 23:11:16 +0200

Junio C Hamano <[email-masked]> writes:

> Tomas Nordin <[email-masked]> writes:
>
>> Hello List
>>
>> The second line of the help message for git commit looks like this:
>
> This seems to have come from 00ea64ed (doc/git-commit: add
> documentation for fixup=[amend|reword] options, 2021-03-15),
> if "git blame" is to be trusted.
>
>>     [--dry-run] [(-c | -C | --squash) <commit> | --fixup [(amend|reword):]<commit>)]
>
> We can have --dry-run but we do not have to, we can have only one of
>
>     "-c <commit>"
>     "-C <commit>",
>     "--squash <commit>",
>     "--fixup amend:<commit>"
>     "--fixup reword:<commit>", or
>     "--fixup <commit>"
>
> as they are mutually exclusive, but it is OK if we have none of
> them.
>
> The last closing parenthesis after <commit> but before the closing
> square bracket is unwanted, I think, as you pointed out.

Maybe explicit grouping of the mutually exclusive option-argument pairs
is better? Like this:

[--dry-run] [((-c | -C | --squash) <commit>) | (--fixup [(amend|reword):]<commit>)]

The closing paren would then make sense. I /think/ this is the way I
would have written it.
-------------------- End of forwarded message --------------------